;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;                                                                                  ;;
;; Project          :   Dex4u OS                                                    ;;
;; Ver              :   00.01                                                       ;;
;; Author           :   Dex                                                         ;;
;; Website          :   www.dex4u.com                                               ;;
;; Forum            :   http://jas2o.forthworks.com/dexforum/                       ;;
;; wiki             :   http://tonymac.asmhackers.net/Wiki/pmwiki.php               ;;
;; Date             :   October 10, 2006                                            ;;
;; Filename         :   DexFunction.inc                                             ;;
;; Assembler Command:   FASM bmpview.asm bmpview.exe                                ;;
;; Copy Right Owners:   Team Dex4u                                                  ;;
;;                                                                                  ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;                                                                                  ;;
;; Team Dex4u       :   0x4e71, bubach, crc, Dex, hidnplayr, jas2o, Solidus         ;;
;;                  :   smiddy, tony(mac), viki.                                    ;;
;;                                                                                  ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;                                                                                  ;;
;; Disclaimer       :                                                               ;;
;; This software is provided "AS IS" without warranty of any kind, either           ;;
;; expressed or implied, including, but not limited to, the implied                 ;;
;; warranties of merchantability and fitness for a particular purpose. The          ;;
;; entire risk as to the quality and performance of this software is with           ;;
;; you.                                                                             ;;
;; In no event will the author's, distributor or any other party be liable to       ;;
;; you for damages, including any general, special, incidental or                   ;;
;; consequential damages arising out of the use, misuse or inability to use         ;;
;; this software (including but not limited to loss of data or losses               ;;
;; sustained by you or third parties or a failure of this software to operate       ;;
;; with any other software), even if such party has been advised of the             ;;
;; possibility of such damages.                                                     ;;
;;                                                                                  ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;====================================================================================;
; Viewbmp                                                                   11/12/04 ;
;------------------------------------------------------------------------------------;
; By jas2o                                                                           ;
;                                                                                    ;
; A demo image viewer, for DexOS.                                                    ;
; Displays a 256 color bmp image, loaded from floppy.                                ;
; Type name of image to load from with in program.                                   ;
; Assemble with fasm, eg:                                                            ;
; A:\fasm viewbmp.asm bmpview.dex                                                    ;
;                                                                                    ;
;====================================================================================;
use32
	ORG   0x400000

	jmp   start
	db    'DEX1' 

msg1:	db 13, " Floppy Load Error, press anykey to exit,",13,0
msg2:	db " Please enter name of bmp to display.",13,0
msg3:	db 13, " The bmp is bigger than (320x200) 256 color or is not a bmp file,",13
	db " press anykey to exit.",13,0

start:
	mov   ax,18h
	mov   ds,ax
	mov   es,ax
 ;----------------------------------------------------;
 ; Get calltable address.                             ;
 ;----------------------------------------------------;

	mov   edi,Functions
	mov   al,0
	mov   ah,0x0a
	int   40h

 ;----------------------------------------------------;
 ; Display start message.                             ;
 ;----------------------------------------------------;

	mov   esi,msg2
	call  [PrintString]
	
 ;----------------------------------------------------;
 ; Get User Input.                                    ;
 ;----------------------------------------------------;

	call  [GetUserInput]
	jc    EscPressed
	mov   [FileName],edi
	mov   [LetterCount],cx
	
 ;----------------------------------------------------;
 ; Load image from disk..                             ;
 ;----------------------------------------------------;
	mov   esi,[FileName]
	mov   edi,LoadMeHere
	call  [FloppyfileLoad]
	jc    Fdderror

 ;----------------------------------------------------;
 ; Check valid bmp.                                   ;
 ;----------------------------------------------------;
DisplayBMP:
	mov   esi,LoadMeHere
	cmp   word [ds:esi],'BM'	
	jnz   bmp_error
	mov   bx,[ds:esi + 18]
	mov   ebp,[ds:esi + 22]
	cmp   bx,320
	ja    bmp_error
	cmp   ebp,200
	ja    bmp_error
	cmp   word [ds:esi + 28],8
	jnz   bmp_error

	mov   ax,0x0013
	call  [RealModeInt10h]

 ;----------------------------------------------------;
 ; Set pal.                                           ;
 ;----------------------------------------------------;
	add   esi,0x36
	mov   cx,256
	mov   dx,0x03c8
	mov   al,0
	out   dx,al
	inc   dx

set_pal:
	mov   al,[esi+2]
	shr   al,2
	out   dx,al
	mov   al,[esi+1]
	shr   al,2
	out   dx,al
	mov   al,[esi]
	shr   al,2
	out   dx,al
	add   esi,4
	loop  set_pal

	lea   dx,[bx+3]
	and   dx,-4
	imul  edi,ebp,320
	add   edi,0xa0000 
	mov   ax,08h
	mov   es,ax

new_line:
	sub   edi,320
	pushad
	mov   cx,bx
	rep   movsb
	popad
	add   esi,edx
	dec   ebp
	jnz   new_line
	jmp   @f

 ;----------------------------------------------------;
 ; Error message.                                     ;
 ;----------------------------------------------------;
Fdderror:
	mov   esi,msg1
	call  [PrintString]
	jmp   @f
 ;----------------------------------------------------;
 ; Error message.                                     ;
 ;----------------------------------------------------;
bmp_error:
	mov   esi,msg3
	call  [PrintString]

 ;----------------------------------------------------;
 ; wait for key press                                 ;
 ;----------------------------------------------------;
@@:
	call  [WaitForKeyPress]
EscPressed:
	call  [SetDex4uFonts]
	ret

 ;----------------------------------------------------;
 ; Data                                               ;
 ;----------------------------------------------------;
FileName	dd  0
LetterCount	dw  0

include 'Dex.inc'
LoadMeHere:
